Open Babel: OBOrbitalData Class Reference

Public Member Functions | Protected Attributes

# OBOrbitalData Class Reference

Used to hold information about orbital energies. More...

`#include <openbabel/generic.h>`

Inheritance diagram for OBOrbitalData:

List of all members.

## Public Member Functions
| OBOrbitalData ()
virtual | ~OBOrbitalData ()
virtual OBGenericData * | Clone (OBBase *) const
OBOrbitalData & | operator= (const OBOrbitalData &)
void | SetAlphaOrbitals (std::vector< OBOrbital > orbitalList)
void | SetBetaOrbitals (std::vector< OBOrbital > orbitalList)
void | SetHOMO (int alpha, int beta=0)
void | SetOpenShell (bool openShell)
bool | IsOpenShell ()
unsigned int | GetAlphaHOMO ()
unsigned int | GetBetaHOMO ()
std::vector< OBOrbital > | GetAlphaOrbitals ()
std::vector< OBOrbital > | GetBetaOrbitals ()
void | LoadClosedShellOrbitals (std::vector< double > energies, std::vector< std::string > symmetries, int alphaHOMO)
void | LoadAlphaOrbitals (std::vector< double > energies, std::vector< std::string > symmetries, int alphaHOMO)
void | LoadBetaOrbitals (std::vector< double > energies, std::vector< std::string > symmetries, int betaHOMO)
void | SetAttribute (const std::string &v)
void | SetOrigin (const DataOrigin s)
virtual const std::string & | GetAttribute () const
unsigned int | GetDataType () const
virtual const std::string & | GetValue () const
virtual DataOrigin | GetOrigin () const
## Protected Attributes
std::vector< OBOrbital > | _alphaOrbitals
std::vector< OBOrbital > | _betaOrbitals
unsigned int | _alphaHOMO
unsigned int | _betaHOMO
bool | _openShell
std::string | _attr
unsigned int | _type
DataOrigin | _source

## Detailed Description

Used to hold information about orbital energies.

## Constructor & Destructor Documentation

OBOrbitalData | ( | ) | `[inline]`

virtual ~OBOrbitalData | ( | ) | `[inline, virtual]`

## Member Function Documentation

virtual OBGenericData* Clone | ( | OBBase * | ) | const`[inline, virtual]`

Reimplemented from OBGenericData.

OBOrbitalData& operator= | ( | const OBOrbitalData & | ) |

void SetAlphaOrbitals | ( | std::vector< OBOrbital > | orbitalList ) | `[inline]`

void SetBetaOrbitals | ( | std::vector< OBOrbital > | orbitalList ) | `[inline]`

void SetHOMO | ( | int | alpha,
|  | int | beta = `0`
| ) |  | `[inline]`

void SetOpenShell | ( | bool | openShell ) | `[inline]`

bool IsOpenShell | ( | ) | `[inline]`

unsigned int GetAlphaHOMO | ( | ) | `[inline]`

unsigned int GetBetaHOMO | ( | ) | `[inline]`

std::vector<OBOrbital> GetAlphaOrbitals | ( | ) | `[inline]`

std::vector<OBOrbital> GetBetaOrbitals | ( | ) | `[inline]`

void LoadClosedShellOrbitals | ( | std::vector< double > | energies,
|  | std::vector< std::string > | symmetries,
|  | int | alphaHOMO
| ) |  |

Convenience function for common cases of closed-shell calculations -- pass the energies and symmetries This method will fill the OBOrbital objects for you.

void LoadAlphaOrbitals | ( | std::vector< double > | energies,
|  | std::vector< std::string > | symmetries,
|  | int | alphaHOMO
| ) |  |

Convenience function to load alpha orbitals in an open-shell calculation.

void LoadBetaOrbitals | ( | std::vector< double > | energies,
|  | std::vector< std::string > | symmetries,
|  | int | betaHOMO
| ) |  |

Convenience function to load beta orbitals in an open-shell calculation.

void SetAttribute | ( | const std::string & | v ) | `[inline, inherited]`

Set the attribute (key), which can be used to retrieve this data.

Referenced by OBGastChrg::AssignPartialCharges(), OBMol::DoTransformations(), OBMol::FindLSSR(), OBMol::FindSSSR(), OBForceField::GetAtomTypes(), OBMol::GetFormula(), OBMol::GetLSSR(), OBForceField::GetPartialCharges(), OBMol::GetSSSR(), OBDescriptor::PredictAndSave(), and OBMol::SetFormula().

void SetOrigin | ( | const DataOrigin | s ) | `[inline, inherited]`

Set the origin of this data, which can be used to filter the data.

Referenced by OBGastChrg::AssignPartialCharges(), OpenBabel::CalcSignedVolume(), OBMol::FindAngles(), OBMol::FindLSSR(), OBMol::FindSSSR(), OBMol::FindTorsions(), OBMol::GetFormula(), OBMol::GetLSSR(), OBMol::GetSSSR(), OBDescriptor::PredictAndSave(), and OBMol::SetFormula().

virtual const std::string& GetAttribute | ( | ) | const`[inline, virtual, inherited]`

Returns:
  The attribute (key), which can be used to retrieve this data

Referenced by OBMoleculeFormat::MakeCombinedMolecule().

unsigned int GetDataType | ( | ) | const`[inline, inherited]`

Returns:
  the data type for this object as defined in OBGenericDataType

virtual const std::string& GetValue | ( | ) | const`[inline, virtual, inherited]`

Base class returns a default value (the attribute type) but should never be called.

Reimplemented in OBCommentData, and OBPairData.

Referenced by OBDepict::DrawMolecule(), OBDescriptor::FilterCompare(), and OBDescriptor::GetValues().

virtual DataOrigin GetOrigin | ( | ) | const`[inline, virtual, inherited]`

## Member Data Documentation

std::vector<OBOrbital> _alphaOrbitals`[protected]`

List of orbitals. In case of unrestricted calculations, this contains the alpha spin-orbitals.

Referenced by OBOrbitalData::LoadAlphaOrbitals(), and OBOrbitalData::LoadClosedShellOrbitals().

std::vector<OBOrbital> _betaOrbitals`[protected]`

Only used if needed (e.g., unrestricted calculations)

Referenced by OBOrbitalData::LoadBetaOrbitals(), and OBOrbitalData::LoadClosedShellOrbitals().

unsigned int _alphaHOMO`[protected]`

Highest occupied molecular orbital for _alphaOrbitals.

Referenced by OBOrbitalData::LoadAlphaOrbitals(), and OBOrbitalData::LoadClosedShellOrbitals().

unsigned int _betaHOMO`[protected]`

Highest occupied for _betaOrbitals (if needed)

Referenced by OBOrbitalData::LoadBetaOrbitals(), and OBOrbitalData::LoadClosedShellOrbitals().

bool _openShell`[protected]`

Whether we store both alpha and beta spin-orbitals (i.e., a restricted open-shell or unrestricted calc.)

Referenced by OBOrbitalData::LoadAlphaOrbitals(), OBOrbitalData::LoadBetaOrbitals(), and OBOrbitalData::LoadClosedShellOrbitals().

std::string _attr`[protected, inherited]`

attribute tag (e.g., "UnitCell", "Comment" or "Author")

Referenced by OBRotamerList::Clone(), and OBNasaThermoData::OBNasaThermoData().

unsigned int _type`[protected, inherited]`

attribute type -- declared for each subclass

Referenced by OBRotamerList::Clone(), and OBNasaThermoData::OBNasaThermoData().

DataOrigin _source`[protected, inherited]`

source of data for accounting

Referenced by OBChiralData::operator=(), OBTorsionData::operator=(), OBAngleData::operator=(), OBConformerData::operator=(), and OBSymmetryData::operator=().

The documentation for this class was generated from the following files:

- generic.h
- generic.cpp

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Friends Defines